/// <reference types="node" />
/// <reference types="node" />
import { PathOrFileDescriptor, PathLike, CopyOptionsSync, CopyOptions } from 'fs-extra';
import inquirer, { CheckboxChoiceOptions, ListChoiceOptions } from 'inquirer';
import { Filter } from 'klaw-sync';
import { NodePlopAPI } from 'node-plop';
import { Ora } from 'ora';
import yargsParser from 'yargs-parser';
import { SeedSources } from '../seeds';
import { ConfigStore } from '../store';
export declare const argv: yargsParser.Arguments;
export declare const env: NodeJS.ProcessEnv;
export declare const basePath: string;
export declare const progressSpinner: Ora;
export interface KeyValuePair {
    key: string;
    value: any;
}
export declare const getDirectories: (relativePath: any) => KeyValuePair[];
export declare const mapToNames: (pairs: KeyValuePair[], field?: string) => any[];
export declare const mapToCheckboxChoices: (pairs: KeyValuePair[], nameField?: string, valueField?: string) => CheckboxChoiceOptions[];
export declare const mapToKeyValues: (options: {
    name: string;
}[]) => KeyValuePair[];
export declare const mapToListChoices: (pairs: KeyValuePair[]) => ListChoiceOptions[];
export declare const mapToSeedChoices: (seeds: SeedSources[]) => ListChoiceOptions[];
export declare const getByName: (array: any, name: any) => any;
export declare const getFoundationUIPath: () => string;
export declare const getDSPath: (name: any) => string;
export declare const getMSFastComponentsPath: () => string;
export declare const getDesignSystemsDirectories: () => KeyValuePair[];
export declare const getDirectoryNames: (dirPath: any) => any[];
export declare const getUIDirectoryNames: () => any[];
export declare const getDsDirectoryNames: (dsName: any) => any[];
export declare const getUIAuthoringConfig: () => any;
export declare const getBaseComponentsDirectories: () => KeyValuePair[];
export declare const getBaseComponentSchema: (name: any) => any;
export declare const getCurrentDirectoryBase: () => string;
export declare const directoryExists: (directory: PathLike) => boolean;
export declare const makeDirectory: (directory: PathLike) => void;
export declare const copyFilesOptions: CopyOptionsSync;
export declare const copyFiles: (source: string, destination: string, options?: CopyOptionsSync) => void;
export declare const copyFilesAsyncOptions: CopyOptions;
export declare const copyFilesAsync: (source: string, destination: string, options?: CopyOptions) => Promise<void>;
export declare const readFile: (file: PathOrFileDescriptor) => string;
export declare const writeFile: (file: PathOrFileDescriptor, data: string) => void;
export declare const writeFileWithAnswers: (file: PathOrFileDescriptor, plop: NodePlopAPI, answers: inquirer.Answers, template?: PathOrFileDescriptor) => void;
export declare const getWriteFileWithData: (plop: NodePlopAPI) => (file: PathOrFileDescriptor, answers: inquirer.Answers, template?: PathOrFileDescriptor) => void;
export declare const getDirectoryInfo: (dirPath: any) => {
    contents: any[];
    name: any;
    version: any;
};
export declare const replaceObjectKeys: (input: object, searchValue: string | RegExp, replaceValue: string) => object;
export declare const combineArrays: (a1: any, a2: any) => any[];
export declare const defaultSort: (a: any, b: any) => 1 | 0 | -1;
export declare const listAllFiles: (rootFolder: string, fileFilter?: Filter) => Array<string>;
export declare const rename: (oldPath: PathLike, newPath: PathLike) => void;
export interface SeedConfigurationUtils {
    configStore: ConfigStore;
    plop: NodePlopAPI;
    progressSpinner: Ora;
    editJSONFile(filePath: string, options: any): any;
    readFile(file: PathOrFileDescriptor): string;
    writeFile(file: PathOrFileDescriptor, data: string): void;
    writeFileWithData(file: PathOrFileDescriptor, answers: inquirer.Answers): void;
    copyFiles(source: string, destination: string, options: CopyOptionsSync): void;
    copyFilesAsync(source: string, destination: string, options: CopyOptionsSync): Promise<void>;
    replaceObjectKeys(input: object, searchValue: string | RegExp, replaceValue: string): object;
    directoryExists(directory: PathLike): boolean;
    makeDirectory(directory: PathLike): void;
    listAllFiles(rootFolder: string, fileFilter: Filter): Array<string>;
    rename(oldPath: PathLike, newPath: PathLike): any;
}
export declare const getSeedConfigurationUtils: (plop: NodePlopAPI) => SeedConfigurationUtils;
//# sourceMappingURL=utils.d.ts.map